--coronaScatterConverter_v0.02

/* MultiScatter properties
  .Scatter_Object : node array
  .Scatter_Object_Percent : float array
  .Scatter_Object_Mask : texturemap array
  .Scatter_Object_Mask_On : boolean array
  .Scatter_Mask_Contrast : float
  .Dummy_Size : float
  .Node_Mesh : node
  .Count : integer
  .Density_Map : texturemap
  .Use_Density_Map : boolean
  .Use_Density_Map_Color : boolean
  .Density_Map_Color : RGB color
  .Density_Map_Color_Range : float
  .Base_Scale : float array
  .Scale_Map : texturemap
  .Use_Scale_Map : boolean
  .Min_Scale_Value : float
  .Random_Rotate : float array
  .Random_Move1 : float array
  .Random_Move2 : float array
  .Use_Normal : float
  .Z_Recovery : float
  .Preview_Count : integer
  .Preview_Type : integer
  .Preview_Point_Count : float
  .Use_Object_Wire_Color : boolean
  .Auto_Update_Preview : boolean
  .Seed : integer
  .Animation_Samples : integer
  .Animation_Speed : float
  .Animation_Type : integer
  .Enable_Fractional_Frame : boolean
  .Animation_Offset_From : integer
  .Animation_Offset_To : integer
  .AniShift_Map : texturemap
  .Use_AniShift_Map : boolean
  .Random_Scale1 : float array
  .Random_Scale2 : float array
  .Collision_Radius : float
  .Collision_Height : float
  .Collision_Penetration : float
  .Generate_Collision : boolean
  .Receive_Collision : boolean
  .Const_Rotate : float array
  .Rotation_Map : texturemap
  .Use_Rotation_Map : boolean array
  .Rotation_Map_Val : float
  .Color_Texture1 : texturemap
  .Use_Color_Texture1 : boolean
  .Use_Pattern : integer
  .Pattern_Channel : integer
  .Pattern_Structure : integer
  .Pattern_RND_Shift : float
  .Pattern_Scale : float
  .Pattern_Affect_TM : boolean
  .Pattern_Affect_Scale : boolean
  .Pattern_ScaleXY : float
  .Pattern_Affect_ScaleZ : boolean
  .Pattern_ScaleZ : float
  .Border_Spline : node
  .Use_Border_Spline : boolean
  .Border_Spline_Projection : integer
  .Border_Spline_Inverse : boolean
  .Border_Use_Surface : boolean
  .Border_Use_Spline : boolean
  .Border_Distance : float
  .Border_Func : maxObject array
  .Border_Func_On : boolean array
  .Use_Camera_Clipping : boolean
  .Camera_Distance : float
  .Camera_Density_Func : maxObject array
  .Camera_Density_On : boolean array
  .Scatter_On : boolean
  .Surf_Spline_Thick : float
  .Surf_Spline_MapU : float
  .Surf_Spline_MapV : float
  .Camera_Preview : node
  .Use_Surf_Density : boolean
  .Surf_Density : float
  .Surf_Density_Unit : float

*/

/* CScatter properties
 .distributionObject (Distribution_object) : node array
  .distributionObjectDensity (3dsmax_sux) : float array
  .scatteredObject (Scattered_object) : node array
  .scatteredObjectFrequency (WTF) : float array
  .randomType (Random_type) : integer
  .count (Number_of_instances) : integer
  .seed : integer
  .translationMinX (Translate_min_x) : worldUnits
  .translationMinY (Translate_min_y) : worldUnits
  .translationMinZ (Translate_min_z) : worldUnits
  .translationMaxX (Translate_max_x) : worldUnits
  .translationMaxY (Translate_max_y) : worldUnits
  .translationMaxZ (Translate_max_z) : worldUnits
  .rotationMinX (Rotate_min_x) : float
  .rotationMinY (Rotate_min_y) : float
  .rotationMinZ (Rotate_min_z) : float
  .rotationMaxX (Rotate_max_x) : float
  .rotationMaxY (Rotate_max_y) : float
  .rotationMaxZ (Rotate_max_z) : float
  .scaleMinX (Scale_min_x) : float
  .scaleMinY (Scale_min_y) : float
  .scaleMinZ (Scale_min_z) : float
  .scaleMaxX (Scale_max_x) : float
  .scaleMaxY (Scale_max_y) : float
  .scaleMaxZ (Scale_max_z) : float
  .scaleMinUniform (Scale_min_uni) : float
  .scaleMaxUniform (Scale_max_uni) : float
  .alignNormals (Align_Z_axis) : boolean
  .previzType (Display_type) : integer
  .previzFraction (Visible_fraction) : float
  .interactiveUpdate (Update_interactively_on_node_changes) : boolean
  
*/

 fn GetSurfaceArea obj =
 (
	local obj = snapshotasmesh obj
	local faceSel= #()
	for f = 1 to obj.numfaces do
	(
		append faceSel f
	)
	setFaceSelection obj faceSel
	local theFaces= getFaceSelection obj
	theArea = meshop.getFaceArea obj theFaces
)

fn convertFrom_MultiScatter orignScatter =
(
	CorScatter = CScatter TODOseed:1
	CorScatter.transform = orignScatter.transform
	
	for i = 1 to (orignScatter.Scatter_Object.count) do
	(
		if orignScatter.Scatter_Object[i] != undefined then
		(
			select orignScatter.Scatter_Object[i]
			append CorScatter.scatteredObject selection[1]
		)
	)
	if orignScatter.Node_Mesh != undefined then
	(
		select orignScatter.Node_Mesh
		append (CorScatter.distributionObject) selection[1]
	)
	
	--CorScatter.distributionObjectDensity = 1
	for i = 1 to CorScatter.scatteredObject.count do
	(
		append CorScatter.scatteredObjectFrequency orignScatter.Scatter_Object_Percent[i]
	)
	CorScatter.randomType = 0
	
	if orignScatter.Use_Surf_Density then
	(
		surf_area = GetSurfaceArea orignScatter.Node_Mesh
		CorScatter.count = ((surf_area*orignScatter.Surf_Density)/(orignScatter.Surf_Density_Unit)^2) as integer
	)
	else
	(
		CorScatter.count = orignScatter.Count
	)
	CorScatter.seed = orignScatter.Seed + 1
	CorScatter.translationMinX = orignScatter.Random_Move1[1]
	CorScatter.translationMinY = orignScatter.Random_Move1[2]
	CorScatter.translationMinZ = orignScatter.Random_Move1[3]
	CorScatter.translationMaxX = orignScatter.Random_Move2[1]
	CorScatter.translationMaxY = orignScatter.Random_Move2[2]
	CorScatter.translationMaxZ = orignScatter.Random_Move2[3]
	CorScatter.rotationMinX = orignScatter.Const_Rotate[1]
	CorScatter.rotationMinY = orignScatter.Const_Rotate[2]
	CorScatter.rotationMinZ = orignScatter.Const_Rotate[3]
	CorScatter.rotationMaxX = orignScatter.Random_Rotate[1]
	CorScatter.rotationMaxY = orignScatter.Random_Rotate[2]
	CorScatter.rotationMaxZ = orignScatter.Random_Rotate[3]
	CorScatter.scaleMinX = orignScatter.Random_Scale1[1]
	CorScatter.scaleMinY = orignScatter.Random_Scale1[2]
	CorScatter.scaleMinZ = orignScatter.Random_Scale1[3]
	CorScatter.scaleMaxX = orignScatter.Random_Scale2[1]
	CorScatter.scaleMaxY = orignScatter.Random_Scale2[2]
	CorScatter.scaleMaxZ = orignScatter.Random_Scale2[3]
	CorScatter.scaleMinUniform = orignScatter.Base_Scale[1]
	CorScatter.scaleMaxUniform = orignScatter.Base_Scale[2]
	CorScatter.alignNormals = case of
	(
		(orignScatter.Use_Normal>=0.5): true
		(orignScatter.Use_Normal<0.5): false
	)
	CorScatter.previzType = 3
	CorScatter.previzFraction = case of
	(
		(CorScatter.Count>=10000): 1
		(CorScatter.Count<10000):amin #(100,100*orignScatter.Preview_Count/orignScatter.Count)
	)
	
--	orignScatter.Scatter_On = false
--	hide orignScatter
	print (orignScatter.name + " converted")
	CorScatter
)

undo "CoronaScatterConverter" on
(
	MultiScatterArray = #()
	
	for tmpMultiScatter in Geometry where classof tmpMultiScatter == MultiScatter do
	(
		appendifunique MultiScatterArray tmpMultiScatter
	)
	
	for tmpMultiScatter in MultiScatterArray do
	(
		tmpCorScatter = convertFrom_MultiScatter tmpMultiScatter
		replaceInstances tmpMultiScatter tmpCorScatter
		delete tmpCorScatter
	)
	
	
)











